#ifndef SURFACE_H
#define SURFACE_H

#include "field.h"

using namespace std;

extern const FieldElement leftside[9], rightside[9], holonomy[8];
extern const int permutation[8];

FieldElement left_endpoint(const FieldElement &orthogonal,
			   const FieldElement &level);
FieldElement right_endpoint(const FieldElement &orthogonal,
			   const FieldElement &level);

// level must be an element with the same argument as orthogonal
// (they must be vectors pointing the same direction)
inline cl_R length_of_level(const FieldElement &orthogonal,
			    const FieldElement &level)
{ 
  return abs((cl_N)(right_endpoint(orthogonal,level)-
		    left_endpoint(orthogonal,level))); }


#endif
